Loading...
Searching...
No Matches
Sip_user_agent

## Macros

#define | sip_user_agent(sip)
| Access a SIP User-Agent header structure sip_user_agent_t from sip_t.
#define | SIP_USER_AGENT_INIT()
| Initializer for structure sip_user_agent_t.
#define | SIPTAG_USER_AGENT(x)
| Tag list item for pointer to a User-Agent header structure sip_user_agent_t.
#define | SIPTAG_USER_AGENT_REF(x)
| Tag list item for reference to a User-Agent header pointer.
#define | SIPTAG_USER_AGENT_STR(s)
| Tag list item for string with User-Agent header value.
#define | SIPTAG_USER_AGENT_STR_REF(x)
| Tag list item for reference to a User-Agent header string.

## Typedefs

typedef struct msg_generic_s | sip_user_agent_t
| @

## Functions

issize_t | sip_user_agent_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP User-Agent header.
issize_t | sip_user_agent_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP User-Agent header.
sip_user_agent_t * | sip_user_agent_init (sip_user_agent_t x[1])
| Initialize a structure sip_user_agent_t.
int | sip_is_user_agent (sip_header_t const *header)
| Test if header object is instance of sip_user_agent_t.
sip_user_agent_t * | sip_user_agent_dup (su_home_t *home, sip_user_agent_t const *hdr))
| Duplicate a list of User-Agent header header structures sip_user_agent_t.
sip_user_agent_t * | sip_user_agent_copy (su_home_t *home, sip_user_agent_t const *hdr))
| Copy a list of User-Agent header header structures sip_user_agent_t.
sip_user_agent_t * | sip_user_agent_make (su_home_t *home, char const *s))
| Make a User-Agent header structure sip_user_agent_t.
sip_user_agent_t * | sip_user_agent_format (su_home_t *home, char const *fmt,...)))
| Make a User-Agent header from formatting result.

## Variables

msg_hclass_t | sip_user_agent_class []
| Header class for User-Agent header.
tag_typedef_t | siptag_user_agent
| Tag for User-Agent header object.
tag_typedef_t | siptag_user_agent_str
| Tag for string with User-Agent header value.

## Detailed Description

## Macro Definition Documentation

## SIP_USER_AGENT_INIT

#define SIP_USER_AGENT_INIT | ( |  | ) |

Initializer for structure sip_user_agent_t.

A static sip_user_agent_t structure for User-Agent header must be initialized with the SIP_USER_AGENT_INIT() macro. For instance,

sip_user_agent_t sip_user_agent = SIP_USER_AGENT_INIT;
sip_user_agent
#define sip_user_agent(sip)
Access a SIP User-Agent header structure sip_user_agent_t from sip_t.
Definition sip_protos.h:6557
SIP_USER_AGENT_INIT
#define SIP_USER_AGENT_INIT()
Initializer for structure sip_user_agent_t.
Definition sip_protos.h:6574
sip_user_agent_t
struct msg_generic_s sip_user_agent_t
@
Definition sip.h:199

## SIPTAG_USER_AGENT

#define SIPTAG_USER_AGENT | ( |  | x | ) |

Tag list item for pointer to a User-Agent header structure sip_user_agent_t.

The SIPTAG_USER_AGENT() macro is used to include a tag item with a pointer to a sip_user_agent_t structure in a tag list.

Parameters

  x | pointer to a sip_user_agent_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_USER_AGENT_REF().

## SIPTAG_USER_AGENT_STR

#define SIPTAG_USER_AGENT_STR | ( |  | s | ) |

Tag list item for string with User-Agent header value.

The SIPTAG_USER_AGENT_STR() macro is used to include a tag item with a string containing value of a sip_user_agent_t header in a tag list.

Parameters

  s | pointer to a string containing User-Agent header value, or NULL.

The string in SIPTAG_USER_AGENT_STR() can be converted to a sip_user_agent_t header structure by giving the string s has second argument to function sip_user_agent_make().

The corresponding tag taking reference parameter is SIPTAG_USER_AGENT_STR_REF().

## Typedef Documentation

## sip_user_agent_t

typedef struct msg_generic_s sip_user_agent_t

@

The User-Agent header contains information about the client user agent originating the request. Its syntax is defined in [H14.43, S10.45] as follows:

User-Agent = "User-Agent" HCOLON server-val *(LWS server-val)
server-val = product / comment
product = token [SLASH product-version]
product-version = token
LWS
#define LWS

The parsed User-Agent header is stored in sip_user_agent_t structure.

The structure sip_user_agent_t contains representation of a SIP User-Agent header.

The sip_user_agent_t is defined as follows:

typedef struct msg_generic_s
{
msg_common_t g_common[1]; // Common fragment info
msg_generic_t *g_next; // Link to next header
char const *g_string; // User-Agent components
} sip_user_agent_t;
msg_common_t
struct msg_common_s msg_common_t
msg_generic_s
msg_generic_s::g_common
msg_common_t g_common[1]
msg_generic_s::g_string
char const * g_string
msg_generic_s::g_next
msg_generic_t * g_next

## Function Documentation

## sip_is_user_agent()

int sip_is_user_agent | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_user_agent_t.

Check if the header class is an instance of User-Agent header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header user_agent
  0 | (false) otherwise

## sip_user_agent_copy()

sip_user_agent_t * sip_user_agent_copy | ( | su_home_t * | home,
|  | sip_user_agent_t const * | hdr )

inline

Copy a list of User-Agent header header structures sip_user_agent_t.

The function sip_user_agent_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  user_agent = sip_user_agent_copy(home, sip->sip_user_agent);
  sip_user_agent_copy
  sip_user_agent_t * sip_user_agent_copy(su_home_t *home, sip_user_agent_t const *hdr))
  Copy a list of User-Agent header header structures sip_user_agent_t.
  Definition sip_protos.h:6704

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_user_agent_dup()

sip_user_agent_t * sip_user_agent_dup | ( | su_home_t * | home,
|  | sip_user_agent_t const * | hdr )

inline

Duplicate a list of User-Agent header header structures sip_user_agent_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  user_agent = sip_user_agent_dup(home, sip->sip_user_agent);
  sip_user_agent_dup
  sip_user_agent_t * sip_user_agent_dup(su_home_t *home, sip_user_agent_t const *hdr))
  Duplicate a list of User-Agent header header structures sip_user_agent_t.
  Definition sip_protos.h:6661

Returns
  A pointer to the newly duplicated sip_user_agent_t header structure, or NULL upon an error.

## sip_user_agent_format()

sip_user_agent_t * sip_user_agent_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a User-Agent header from formatting result.

Make a new sip_user_agent_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_user_agent_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_user_agent_init()

sip_user_agent_t * sip_user_agent_init | ( | sip_user_agent_t | x[1] | ) |

inline

Initialize a structure sip_user_agent_t.

An sip_user_agent_t structure for User-Agent header can be initialized with the sip_user_agent_init() function/macro. For instance,

sip_user_agent_t sip_user_agent;
sip_user_agent_init(&sip_user_agent);
sip_user_agent_init
sip_user_agent_t * sip_user_agent_init(sip_user_agent_t x[1])
Initialize a structure sip_user_agent_t.
Definition sip_protos.h:6592

## sip_user_agent_make()

sip_user_agent_t * sip_user_agent_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a User-Agent header structure sip_user_agent_t.

The function sip_user_agent_make() makes a new sip_user_agent_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_user_agent_t header structure, or NULL upon an error.

## Variable Documentation

## sip_user_agent_class

msg_hclass_t sip_user_agent_class[]

extern

Header class for User-Agent header.

The header class sip_user_agent_class defines how a SIP User-Agent header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_user_agent_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.